/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import java.security.Principal;

import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;


/**
 * <p>
 * Mock implementation of HttpServletRequest, this class is just used for testing purpose.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 2.0
 */
public class MockHttpServletRequest implements HttpServletRequest {

    /**
     * <p>
     * Implementation of getRequestURI().
     * </p>
     *
     * @return "/test/static".
     */
    public String getRequestURI() {
        return "/test/static";
    }

    /**
     * <p>
     * Implementation of getQueryString().
     * </p>
     *
     * @return "id=777".
     */
    public String getQueryString() {
        return "id=777";
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Map getParameterMap() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param key key
     * @param value value
     */
    public void addParameter(String key, String value) {
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param name name
     * @param value value
     */
    public void addHeader(String name, String value) {

    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param name name.
     *
     * @return null.
     */
    public String getHeader(String name) {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Enumeration getHeaderNames() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getAuthType() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Cookie[] getCookies() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0
     *
     * @return null.
     */
    public long getDateHeader(String arg0) {
        return 0;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public int getIntHeader(String arg0) {
        return 0;
    }

    /**
     * <p>
     * Implementation of getMethod().
     * </p>
     *
     * @return GET.
     */
    public String getMethod() {
        return "GET";
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getPathInfo() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getPathTranslated() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getContextPath() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getRemoteUser() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0
     *
     * @return false.
     */
    public boolean isUserInRole(String arg0) {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Principal getUserPrincipal() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getRequestedSessionId() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public StringBuffer getRequestURL() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getServletPath() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public HttpSession getSession(boolean arg0) {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public HttpSession getSession() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return false.
     */
    public boolean isRequestedSessionIdValid() {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return false.
     */
    public boolean isRequestedSessionIdFromCookie() {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return false.
     */
    public boolean isRequestedSessionIdFromURL() {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return false.
     */
    public boolean isRequestedSessionIdFromUrl() {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public Object getAttribute(String arg0) {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Enumeration getAttributeNames() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getCharacterEncoding() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg9.
     *
     * @throws UnsupportedEncodingException when the encoding is not supported.
     */
    public void setCharacterEncoding(String arg0) throws UnsupportedEncodingException {
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return 0.
     */
    public int getContentLength() {
        return 0;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getContentType() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     *
     * @throws IOException when any io related problems.
     */
    public ServletInputStream getInputStream() throws IOException {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Enumeration getParameterNames() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getProtocol() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getScheme() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getServerName() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return 0.
     */
    public int getServerPort() {
        return 0;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     *
     * @throws IOException when any io related problems.
     */
    public BufferedReader getReader() throws IOException {
        return null;
    }

    /**
     * <p>
     * Always return "127.0.0.1" ip address.
     * </p>
     *
     * @return "127.0.0.1".
     */
    public String getRemoteAddr() {
        return "127.0.0.1";
    }

    /**
     * <p>
     * Always return "localhost".
     * </p>
     *
     * @return "localhost".
     */
    public String getRemoteHost() {
        return "localhost";
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     * @param arg1 arg1.
     */
    public void setAttribute(String arg0, Object arg1) {
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     */
    public void removeAttribute(String arg0) {
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Locale getLocale() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public Enumeration getLocales() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return false.
     */
    public boolean isSecure() {
        return false;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public String getRealPath(String arg0) {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return 0.
     */
    public int getRemotePort() {
        return 0;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getLocalName() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return null.
     */
    public String getLocalAddr() {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @return 0.
     */
    public int getLocalPort() {
        return 0;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public Enumeration getHeaders(String arg0) {
        return null;
    }

    /**
     * <p>
     * Get the value that binds to the given parameter key.
     * </p>
     *
     * @param key key to get the corresponding value.
     *
     * @return the value that binds to the given parameter key.
     */
    public String getParameter(String key) {
        return null;
    }

    /**
     * <p>
     * Get the value that binds to the given parameter key.
     * </p>
     *
     * @param key key to get the corresponding value.
     *
     * @return the value that binds to the given parameter key.
     */
    public String[] getParameterValues(String key) {
        return null;
    }

    /**
     * <p>
     * not implemented.
     * </p>
     *
     * @param arg0 arg0.
     *
     * @return null.
     */
    public RequestDispatcher getRequestDispatcher(String arg0) {
        return null;
    }
}
